<?php
/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */

define('SHOPGATE_PLUGIN_API_REQUEST', 1);

// Include the shopgate library (i.e. core.php; customers.php; JSON.php etc.)
include_once dirname(__FILE__) . '/shopgate_library/shopgate.php';

// Change to a base directory to include all files from
$dir = realpath(dirname(__FILE__) . "/../../../");
chdir($dir);

include_once dirname(__FILE__) . '/base/shopgate_config.php';
$sgConfig = new ShopgateConfigOsCommerce();

// application_top couldn't read the browser language here and also no session is set!
if (empty($_GET['language'])) {
	// Use the language from the shopgate config file
	$_GET['language'] = strtolower($sgConfig->getLanguage());
}

// Check if the shoppingsystem is osCommerce or swisscart
if (file_exists('admin/includes/application_top.php')) {
	// Find the define Statement and execute it if found
	$fileCont = file_get_contents('admin/includes/application_top.php');
	if ($fileCont !== false) {
		$matches = array();
		if (preg_match(
			'/define\([\'"]SWISSCART_VERSION[\'"].*,.*[\'"](?P<swisscartVersion>.*)[\'"]\);/',
			$fileCont, $matches
		)) {
			// Only one match expected
			$swisscartVersion = !empty($matches['swisscartVersion'])
				? $matches['swisscartVersion'] : '';
			define('SWISSCART_VERSION', $swisscartVersion);
		}
	}
}

// on swisscart the admin application_top file must be loaded instead of the frontend application_top file!
if (defined('SWISSCART_VERSION') && strlen(SWISSCART_VERSION) > 0) {
	// move filesystem cursor to admin folder first
	chdir('admin');

	include_once('includes/application_top.php');

	// password functions inclusion may be missing in the backend application_top file!
	if (!function_exists('tep_validate_password')) {
		require(rtrim(DIR_WS_FUNCTIONS, "/") . '/password_funcs.php');
	}

	// currencies class needed!
	if (!class_exists('currencies')) {
		require(rtrim(DIR_WS_CLASSES, "/") . '/currencies.php');
	}

	// go back again in filesystem afterwards
	chdir('..');
} else {
	include_once('includes/application_top.php');
}

// Now the plugin can be included
include_once dirname(__FILE__) . '/plugin.php';

$sgMarketplaceFieldName = 'marketplace';
$marketplaceIsoCode2    = '';
$pluginTypeMap          = array();
if (!empty($_REQUEST[$sgMarketplaceFieldName])) {
	$marketplaceIsoCode2 = strtoupper($_REQUEST[$sgMarketplaceFieldName]);
	$pluginTypeMap       = $pluginTypeMap = ShopgatePluginType::getMap();
	if (!array_key_exists($marketplaceIsoCode2, $pluginTypeMap)) {
		$pluginTypeMap[$marketplaceIsoCode2] = 1;
	}
}
if ($sgConfig->getIsUsaPlugin() === null) {
	if ($pluginTypeMap[$marketplaceIsoCode2]) {
		$sgConfig->setIsUsaPlugin(1);
		$sgConfig->saveFile(array('is_usa_plugin'));
	}
}
if ($sgConfig->getIsUsaPlugin() || !empty($marketplaceIsoCode2) && $pluginTypeMap[$marketplaceIsoCode2]) {
	$shopgateFramework = new ShopgatePluginOsCommerceUsa();
} else {
	$shopgateFramework = new ShopgatePluginOsCommerce();
}
$shopgateFramework->handleRequest($_REQUEST);
